# TSimpleShapeRenderable Class Reference
[Data Structures]

Inheritance diagram for TSimpleShapeRenderable:

List of all members.

## Public Member Functions
virtual I3DShRenderable::EType MCCOMAPI | GetGeometryType () const
virtual const TPointMesh *MCCOMAPI | GetPointMesh () const
virtual const TSegmentMesh *MCCOMAPI | GetSegmentMesh () const
virtual MCCOMErr MCCOMAPI | GetFMesh (real lod, FacetMesh **amesh)
virtual void MCCOMAPI | GetBoundingBox (TBBox3D &bb)
virtual TRenderableFlags MCCOMAPI | GetRenderableFlags (void) const
virtual MCCOMErr MCCOMAPI | SetRenderableFlags (const TRenderableFlags flags)
## Static Public Member Functions
static void | Create (TSimpleShapeRenderable **renderable)
## Public Attributes
TRenderableFlags | fFlags
TBBox3D | fBox
const void * | fMesh
I3DShRenderable::EType | fGeometryType
TShadingApproximation | fShader
## Protected Member Functions
| TSimpleShapeRenderable ()
virtual MCCOMErr MCCOMAPI | SelfGetShadingApproximation (TShadingApproximation &shadingApprox, uint32 uvSpaceID) const

## Detailed Description

Implements a simple renderable where the shape data is aliased in the structure. No LOD or deformation support, just returns shape data directly to the caller. Perfect for wireframes, etc. Shape creation and bbox calculations are not deferred. Renderable flags can be specified directly.

## Constructor & Destructor Documentation

TSimpleShapeRenderable::TSimpleShapeRenderable | ( |  | ) | `[protected]`

## Member Function Documentation

static void TSimpleShapeRenderable::Create | ( | TSimpleShapeRenderable ** | renderable | ) | `[static]`

virtual void MCCOMAPI TSimpleShapeRenderable::GetBoundingBox | ( | TBBox3D & | bb | ) | `[inline, virtual]`

Returns the bounding box of the renderable in local coordinates (for triangle meshes).

Parameters:

  | bb | The bounding box that is returned.

Reimplemented from TCountedRenderable.

virtual MCCOMErr MCCOMAPI TSimpleShapeRenderable::GetFMesh | ( | real | lod,
|  | FacetMesh ** | amesh |
| ) |  |  | `[virtual]`

Returns a pointer to the triangle mesh contained in this renderable (see GetGeometryType()).

Parameters:

  | lod | The lod that is requested.
  | amesh | A pointer to the mesh that is returned.

Reimplemented from TCountedRenderable.

virtual I3DShRenderable::EType MCCOMAPI TSimpleShapeRenderable::GetGeometryType | ( |  | ) | const`[virtual]`

Returns the type of geometry that should be rendered (points, segments or triangles...)

Reimplemented from TCountedRenderable.

virtual const TPointMesh* MCCOMAPI TSimpleShapeRenderable::GetPointMesh | ( |  | ) | const`[virtual]`

Returns a pointer to the point mesh contained in this renderable. Returns NULL if the renderable is not a point mesh (see GetGeometryType()).

Reimplemented from TCountedRenderable.

virtual TRenderableFlags MCCOMAPI TSimpleShapeRenderable::GetRenderableFlags | ( | void |  | ) | const`[virtual]`

Returns the flags associated with this renderable. See TRenderableFlags for more info.

Reimplemented from TCountedRenderable.

virtual const TSegmentMesh* MCCOMAPI TSimpleShapeRenderable::GetSegmentMesh | ( |  | ) | const`[virtual]`

Returns a pointer to the segment mesh contained in this renderable. Returns NULL if the renderable is not a segment mesh (see GetGeometryType()).

Reimplemented from TCountedRenderable.

virtual MCCOMErr MCCOMAPI TSimpleShapeRenderable::SelfGetShadingApproximation | ( | TShadingApproximation & | shadingApprox,
|  | uint32 | uvSpaceID |
| ) |  |  | const`[protected, virtual]`

Reimplemented from TCountedRenderable.

virtual MCCOMErr MCCOMAPI TSimpleShapeRenderable::SetRenderableFlags | ( | const TRenderableFlags | flags | ) | `[virtual]`

Sets the flags associated with this renderable.

Parameters:

  | flags | The flags.

Reimplemented from TCountedRenderable.

## Member Data Documentation

TBBox3D TSimpleShapeRenderable::fBox

TRenderableFlags TSimpleShapeRenderable::fFlags

I3DShRenderable::EType TSimpleShapeRenderable::fGeometryType

const void* TSimpleShapeRenderable::fMesh

TShadingApproximation TSimpleShapeRenderable::fShader

The documentation for this class was generated from the following file:

- CountedRenderable.h